﻿// Upgrade NOTE: replaced 'mul(UNITY_MATRIX_MVP,*)' with 'UnityObjectToClipPos(*)'

Shader "Custom/VertexColor" {
	Properties {
		_ColorTint ("Tint", Color) = (1,1,1,1)
		_MainTex ("Base (RGB)", 2D) = "white" {}
		_FogColor ("Fog Color (RGB)", Color) = (0.5, 0.5, 0.5, 1.0)
		_FogStart ("Fog Start", Float) = 0.0
		_FogEnd ("Fog End", Float) = 10.0
		_Intensity ("Intensity", Float) = 3.0
	}
	SubShader {
		Tags { "RenderType"="Opaque" }
		// FOG
		Fog { Mode off }
		LOD 200
		
		CGPROGRAM
		#pragma surface surf Lambert vertex:myvert finalcolor:mycolor
		#pragma target 3.0


		struct Input {
			fixed4 vertColor;
			float2 uv_MainTex;
		// FOG
			float fog;
// ディザリング
//float4 screenPos; 
		};


		// FOG
		sampler2D _MainTex;
		fixed4 _ColorTint;
		fixed4 _FogColor;
		float _FogStart;
		float _FogEnd;
		float _Intensity;

// ディザリング
//sampler3D   _DitherMaskLOD;
        
		void myvert(inout appdata_full v, out Input o){
			UNITY_INITIALIZE_OUTPUT(Input, o);
			o.vertColor = v.color;

			// FOG
			float zpos = UnityObjectToClipPos(v.vertex).z;
			o.fog = saturate(1.0 - (_FogEnd - zpos) / (_FogEnd - _FogStart));
		}

		void surf (Input IN, inout SurfaceOutput o) {

// ディザリングで半透明を表現
//half alphaRef = tex3D(_DitherMaskLOD, float3(IN.screenPos.xy / IN.screenPos.w * _ScreenParams.xy * 0.25, _ColorTint.a*0.9375)).a;
//clip(alphaRef - 0.01);

			o.Albedo = tex2D (_MainTex, IN.uv_MainTex).rgb * IN.vertColor.rgb * (_LightColor0.rgb * 0.4 + 0.3);
		}

		void mycolor (Input IN, SurfaceOutput o, inout fixed4 color)
		{
		// FOG
			fixed3 fogColor = _FogColor.rgb;
			color.rgb = lerp(color.rgb, fogColor, IN.fog);
			color *= _ColorTint * _Intensity;
		}


		ENDCG
	}
	FallBack "Diffuse"


}